install.packages("sound")
library(sound)

wav = loadSample("whitenoise.wav")
w = sound(wav)

#plot(0:(length(w)-1),w,type="l")
plot(0:(length(w)-1),w,xlim=c(0,44100/440),ylim=c(-1,1),type="l")


f = fft(w)

p = sqrt(Re(f) ** 2 + Im(f) ** 2) # パワースペクトル **は^、べき乗
x = 0:(length(p)-1)
x = x / (length(x) / rate(wav)) # rateはsoundライブラリの関数
xmax = max(x) / 2
#plot(x, p, type="l", xlim=c(0, xmax), log="y")

plot(x, p, type="l", xlim=c(420, 900), ylim=c(0.1, 10^15), log="y",
panel.first = grid(NULL, NULL, lty = 2, col = "#A9BEAA"),
xlab="freq", ylab="power")


pdb = 20*log10(sqrt(p)/44100)	# dB表記に変える
plot(x, pdb, type="l", xlim=c(420, 900), ylim=c(-100,0))






##############

w1 = sound(loadSample("sine440.wav"))
w2 = sound(loadSample("sine660_025.wav"))
w3 = sound(loadSample("sine880_04.wav"))
w4 = sound(loadSample("whitenoise.wav"))

f1 = fft(w1)
f2 = fft(w2)
f3 = fft(w3)
f4 = fft(w4)

p1 = sqrt(Re(f1)^2 + Im(f1)^2)
p2 = sqrt(Re(f2)^2 + Im(f2)^2)
p3 = sqrt(Re(f3)^2 + Im(f3)^2)
p4 = sqrt(Re(f4)^2 + Im(f4)^2)


x = 0:(length(p1)-1)
x = x / (length(x) / 44100)
xmax = max(x) / 2

xlim = c(420, 900)
ylim = c(10^1, 10^5)

plot(x, p1, type="l", xlim=xlim, ylim=ylim, log="y", xlab="", ylab="", col=rgb(1,0,0), xaxt="n", yaxt="n", las=1)
par(new=T)
plot(x, p2, type="l", xlim=xlim, ylim=ylim, log="y", xlab="", ylab="", col=rgb(0,1,0), xaxt="n", yaxt="n", las=1)
par(new=T)
plot(x, p3, type="l", xlim=xlim, ylim=ylim, log="y", xlab="", ylab="", col=rgb(0,0,1), xaxt="n", yaxt="n", las=1)
par(new=T)
plot(x, p4, type="l", xlim=xlim, ylim=ylim, log="y", xlab="", ylab="", col=rgb(0,0,0), las=1,
panel.first = grid(NULL, NULL, lty = 2, col = "#A9BEAA"))

